Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
- Adaptations
- Analyzer
- AnalyzerPlugins
- Checkable
- ConstantFolder
- ContextErrors
- ContextMode
- Contexts
- DestructureTypes
- Duplicators
- EtaExpansion
- Fingerprint
- Implicits
- ImplicitsStats
- Infer
- Macros
- MacrosStats
- MethodSynthesis
- Namers
- NamesDefaults
- PatternTypers
- RefChecks
- StdAttachments
- StructuredTypeStrings
- SuperAccessors
- SyntheticMethods
- Tags
- TreeCheckers
- TypeDiagnostics
- TypeStrings
- Typers
- TypersStats
- TypersTracking
- Unapplies

t

scala.tools.nsc.typechecker

# NamesDefaults 

###

#### trait NamesDefaults extends AnyRef

Self Type
  Analyzer
Source
  NamesDefaults.scala
Version

  1.0

Linear Supertypes
AnyRef, Any
Known Subclasses
erasure, treeChecker, ScaladocAnalyzer, InteractiveAnalyzer, Erasure, Duplicator, SpecializationDuplicator, Analyzer, Duplicators, TreeCheckers
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. NamesDefaults
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class ConstructorDefaultsAttachment extends AnyRef
2.  class DefaultsOfLocalMethodAttachment extends AnyRef
3.  case class NamedApplyInfo (qual: Option[Global.Tree], targs: List[Global.Tree], vargss: List[List[Global.Tree]], blockTyper: Analyzer.Typer) extends Product with Serializable

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from NamesDefaults to any2stringadd[NamesDefaults] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (NamesDefaults, B)
   Implicit
     This member is added by an implicit conversion from NamesDefaults to ArrowAssoc[NamesDefaults] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def addDefaults(givenArgs: List[Global.Tree], qual: Option[Global.Tree], targs: List[Global.Tree], previousArgss: List[List[Global.Tree]], params: List[Global.Symbol], pos: Position, context: Analyzer.Context): (List[Global.Tree], List[Global.Symbol])

   Extend the argument list `givenArgs` with default arguments.

   Extend the argument list `givenArgs` with default arguments. Defaults are added as named arguments calling the corresponding default getter.

   Example: given def foo(x: Int = 2, y: String = "def") foo(y = "lt") the argument list (y = "lt") is transformed to (y = "lt", x = foo$default$1())

7.  def allArgsArePositional(a: Array[Int]): Boolean

   returns `true` if every element is equal to its index

8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
10.  def defaultGetter(param: Global.Symbol, context: Analyzer.Context): Global.Symbol

    For a parameter with default argument, find the method symbol of the default getter.

11.  def ensuring(cond: (NamesDefaults) ⇒ Boolean, msg: ⇒ Any): NamesDefaults
    Implicit
      This member is added by an implicit conversion from NamesDefaults to Ensuring[NamesDefaults] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (NamesDefaults) ⇒ Boolean): NamesDefaults
    Implicit
      This member is added by an implicit conversion from NamesDefaults to Ensuring[NamesDefaults] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: ⇒ Any): NamesDefaults
    Implicit
      This member is added by an implicit conversion from NamesDefaults to Ensuring[NamesDefaults] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): NamesDefaults
    Implicit
      This member is added by an implicit conversion from NamesDefaults to Ensuring[NamesDefaults] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from NamesDefaults to StringFormat[NamesDefaults] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
21.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
22.  def isNamedArg(arg: Global.Tree): Boolean
23.  def makeNamedTypes(syms: List[Global.Symbol]): collection.immutable.List[Global.NamedType]
24.  def missingParams[T](args: List[T], params: List[Global.Symbol], argName: (T) ⇒ Option[Global.Name]): (List[Global.Symbol], Boolean)

    Returns the parameter symbols of an invocation expression that are not defined by the list of arguments.

    Returns the parameter symbols of an invocation expression that are not defined by the list of arguments.

    args

      The list of arguments

    params

      The list of parameter symbols of the invoked method

    argName

      A function that extracts the name of an argument expression, if it is a named argument.

25.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
26.  final def notify(): Unit
    Definition Classes
      AnyRef
27.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
28.  def removeNames(typer: Analyzer.Typer)(args: List[Global.Tree], params: List[Global.Symbol]): (List[Global.Tree], Array[Int])

    Removes name assignments from args.

    Removes name assignments from args. Additionally, returns an array mapping argument indices from call-site-order to definition-site-order.

    Verifies that names are not specified twice, and positional args don't appear after named ones.

29.  def reorderArgs[T](args: List[T], pos: (Int) ⇒ Int)(implicit arg0: ClassTag[T]): List[T]

    pos

      maps indices from old to new

30.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
31.  def toString(): String
    Definition Classes
      AnyRef → Any
32.  def transformNamedApplication(typer: Analyzer.Typer, mode: Mode, pt: Global.Type)(tree: Global.Tree, argPos: (Int) ⇒ Int): Global.Tree

    Transform a function application into a Block, and assigns typer.context .namedApplyBlockInfo to the new block as side-effect.

    Transform a function application into a Block, and assigns typer.context .namedApplyBlockInfo to the new block as side-effect. If tree has the form Apply(fun, args) first the function "fun" (which might be an application itself!) is transformed into a block of the form { val qual$1 = qualifier_of_fun val x$1 = arg_1_of_fun ... val x$n = arg_n_of_fun qual$1.fun[targs](x$1, ...)...(..., x$n) } then for each argument in args, a value is created and entered into the block. finally the application expression of the block is updated. { val qual$1 = .. ... val x$n = ... > val qual$n+1 = arg(1) > ... > val qual$n+m = arg(m) > qual$1.fun[targs](x$1, ...)...(..., x$n)(x$n+1, ..., x$n+m) }

    typer

      the typer calling this method; this method calls typer.doTypedApply

    mode

      the mode to use for calling typer.doTypedApply

    pt

      the expected type for calling typer.doTypedApply

    returns

      the transformed application (a Block) together with the NamedApplyInfo. if isNamedApplyBlock(tree), returns the existing context.namedApplyBlockInfo

33.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
34.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
35.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  def →[B](y: B): (NamesDefaults, B)
    Implicit
      This member is added by an implicit conversion from NamesDefaults to ArrowAssoc[NamesDefaults] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from NamesDefaults to any2stringadd[NamesDefaults]

### Inherited by implicit conversion StringFormat from NamesDefaults to StringFormat[NamesDefaults]

### Inherited by implicit conversion Ensuring from NamesDefaults to Ensuring[NamesDefaults]

### Inherited by implicit conversion ArrowAssoc from NamesDefaults to ArrowAssoc[NamesDefaults]

### Ungrouped